<script lang="ts">
  import PageHeader from "$lib/components/layout/PageHeader.svelte";
  import UserInfo from "$lib/components/pages/user-dashboard/UserInfo.svelte";
  import AccountLink from "$lib/components/pages/user-dashboard/AccountLink.svelte";
  import discordImg from "$lib/assets/images/user_page/discord-mascot.png";
  import linkedinImg from "$lib/assets/images/user_page/linkedIn_icon_circle.png";
  import Env from "$lib/Env";
  import { authTokenParsed, userInfo } from "$stores/authStore";
  import { page } from "$app/stores";
  import { onMount } from "svelte";
  import type { Page } from "@sveltejs/kit";
  import { discoverableTeams, userTeams, activeTeams, archivedTeams } from "./stores";
  import type { UserTeamsSub$result } from '$houdini';

  type SubTab = {
    title: string;
    route: string;
  };

  type Tab = {
    title: string;
    route?: string;
    subTabs?: SubTab[];
  };

  let tabs: Tab[];

  $: tabs = [
    { title: "Discover Teams", route: "/user-dashboard/teams/discover" },
    {
      title: "Team Management",
      route: "/user-dashboard/teams",
      subTabs: [
        ...$activeTeams.map(team => ({
          title: team.long_name || team.name,
          route: `/user-dashboard/teams/${team.id}`
        })),
        { title: "Create a Team", route: "/user-dashboard/teams/create" }
      ]
    },
    // hack to hide this tab if there are no archived teams
    ...($archivedTeams.length === 0 ? [] :
      [{
        title: "My Results",
        route: "/user-dashboard/results",
        subTabs: resultsSubTabs($archivedTeams),
      }])
  ];
  $: console.log(tabs);

  function resultsSubTabs(teams: UserTeamsSub$result['teams']): SubTab[] {
    let ret: SubTab[] = [];
    for (let team of teams) {
      const group_names = team.events.map(e => e.event.event_group?.name)
      let route = `/user-dashboard/teams/${team.id}`
      if (group_names.some(name => name?.includes("2024"))) {
        route = `/results/2024/teams/${team.id}`
      } else if (group_names.some(name => name?.includes("2025"))) {
        route = `/results/2025/teams/${team.id}`
      }
      ret.push({
        title: team.long_name || team.name,
        route: route,
      })
    }
    return ret;
  }

  function getDomain(email: string) {
    return email.split("@")[1];
  }

  onMount(async () => {
    if (!$authTokenParsed) throw new Error("User not logged in"); // type check
    // setup GQL subscriptions for team management pages
    await userTeams.listen({ user_id: $authTokenParsed.id });
    await discoverableTeams.listen({ domain: getDomain($authTokenParsed.email), userId: $authTokenParsed.id });
  });

  function getLinkClass(page: Page, path?: string) {
    return path && page.url.pathname === path ? "hover:text-secondary text-secondary" : "hover:text-white text-white";
  }
</script>

<PageHeader title="Account Management" />

<div class="flex flex-col lg:flex-row">
  <div class="pt-1 lg:pt-5 lg:border-2 lg:w-fit lg:max-w-[33%] h-fit lg:sticky lg:top-32">
    <UserInfo />
    <div class="grid grid-cols-1 gap-5 m-3">
      <AccountLink accountName={$userInfo?.discord_username} isLinked={!!$userInfo?.discord_linked} logoText="Discord"
                   logoImg={discordImg} />
    </div>
    <div class="grid grid-cols-1 gap-2 m-3">
      {#if $userInfo?.attributes?.store_url}
        <a class="md:text-lg" target="_blank"
           href={$userInfo.attributes.store_url}>
          Redeem Store Merch
        </a>
      {/if}
      {#if $userInfo?.attributes?.mvt_url}
        <a class="md:text-lg" target="_blank"
           href={$userInfo.attributes.mvt_url}>
          Redeem MVT Prize
        </a>
      {/if}
      {#if $userInfo?.attributes?.mvt_url}
        <a class="md:text-lg" target="_blank"
           href={$userInfo.attributes.store_url}>
          Redeem MIT Prize
        </a>
      {/if}
    </div>
    <ul class="flex flex-col justify-evenly gap-1 p-4 bg-cyber-blue-900">
      {#each tabs as tab}
        {#if tab.route || tab.subTabs?.length}
          <a
            href={tab.route}
            class="text-xl 2xl:text-2xl max-lg:py-1 font-semibold whitespace-nowrap {getLinkClass($page, tab.route)}">
            {tab.title}
          </a>
        {/if}

        {#if tab.subTabs}
          <ul class="ml-8">
            {#each tab.subTabs as subTab}
              <a
                href={subTab.route}
                class="text-l 2xl:text-xl flex flex-row cursor-pointer py-1
                       font-semibold text-pretty overflow-hidden {getLinkClass($page, subTab.route)}">
                {subTab.title}
              </a>
            {/each}
          </ul>
        {/if}
      {/each}
    </ul>
  </div>
  <div class="my-12 w-full">
    <slot />
  </div>
</div>
